
local BunkerSilo_update = BunkerSilo.update
BunkerSilo.update = function(self, dt)
	BunkerSilo_update(self, dt)
	if self.isClient and g_currentMission.controlPlayer and self.playerInRange then
		if self.state == BunkerSilo.STATE_DRAIN and (g_currentMission:getIsServer() or g_currentMission.isMasterUser) and self.fillLevel > 0 and self.fillLevel < 20000 then
			if InputBinding.hasEvent(InputBinding.BGA_CLEAR) then
				g_client:getServerConnection():sendEvent(WWEK_BunkerSiloClearEvent:new(self));
			else
				g_currentMission:addHelpButtonText(g_i18n:getText("input_BGA_CLEAR"), InputBinding.BGA_CLEAR);
			end
		end
	end
end

WWEK_BunkerSiloClearEvent = {}
WWEK_BunkerSiloClearEvent_mt = Class(WWEK_BunkerSiloClearEvent, Event)
InitEventClass(WWEK_BunkerSiloClearEvent, "WWEK_BunkerSiloClearEvent")
WWEK_BunkerSiloClearEvent.emptyNew = function (self)
	local self = Event:new(WWEK_BunkerSiloClearEvent_mt)
	return self
end
WWEK_BunkerSiloClearEvent.new = function (self, bunkerSilo)
	local self = WWEK_BunkerSiloClearEvent:emptyNew()
	self.bunkerSilo = bunkerSilo
	return self
end
WWEK_BunkerSiloClearEvent.writeStream = function (self, streamId, connection)
	streamWriteInt32(streamId, networkGetObjectId(self.bunkerSilo))
end
WWEK_BunkerSiloClearEvent.readStream = function (self, streamId, connection)
	self.bunkerSilo = networkGetObject(streamReadInt32(streamId))
	self.run(self, connection)
end
WWEK_BunkerSiloClearEvent.run = function (self, connection)
	if not connection.getIsServer(connection) then
		local bunkerSilo = self.bunkerSilo
		local area = bunkerSilo.bunkerSiloArea
		TipUtil.changeFillTypeAtArea(area.sx,area.sz, area.wx,area.wz, area.hx,area.hz, bunkerSilo.outputFillType, bunkerSilo.inputFillType)
		self.bunkerSilo:setState(BunkerSilo.STATE_FILL, true)
		self.bunkerSilo:raiseDirtyFlags(self.bunkerSilo.bunkerSiloDirtyFlag);
	end
end

